import 'dart:async';
import 'dart:developer';
import 'dart:io';

import 'package:easy_localization/easy_localization.dart';
import 'package:flutter/material.dart';
import 'package:hmg_patient_app_new/core/api_consts.dart';
import 'package:hmg_patient_app_new/core/app_assets.dart';
import 'package:hmg_patient_app_new/core/app_state.dart';
import 'package:hmg_patient_app_new/core/cache_consts.dart';
import 'package:hmg_patient_app_new/core/dependencies.dart';
import 'package:hmg_patient_app_new/core/enums.dart';
import 'package:hmg_patient_app_new/core/utils/date_util.dart';
import 'package:hmg_patient_app_new/features/immediate_livecare/immediate_livecare_view_model.dart';
import 'package:hmg_patient_app_new/features/payfort/models/apple_pay_request_insert_model.dart';
import 'package:hmg_patient_app_new/core/utils/size_utils.dart';
import 'package:hmg_patient_app_new/core/utils/utils.dart';
import 'package:hmg_patient_app_new/extensions/string_extensions.dart';
import 'package:hmg_patient_app_new/extensions/widget_extensions.dart';
import 'package:hmg_patient_app_new/features/my_appointments/my_appointments_view_model.dart';
import 'package:hmg_patient_app_new/features/payfort/payfort_view_model.dart';
import 'package:hmg_patient_app_new/features/paytabs/models/paytabs_transaction_response_model.dart';
import 'package:hmg_patient_app_new/features/paytabs/paytabs_view_model.dart';
import 'package:hmg_patient_app_new/generated/locale_keys.g.dart';
import 'package:hmg_patient_app_new/presentation/book_appointment/livecare/immediate_livecare_pending_request_page.dart';
import 'package:hmg_patient_app_new/presentation/home/navigation_screen.dart';
import 'package:hmg_patient_app_new/presentation/insurance/insurance_home_page.dart';
import 'package:hmg_patient_app_new/widgets/appbar/collapsing_list_view.dart';
import 'package:hmg_patient_app_new/theme/colors.dart';
import 'package:hmg_patient_app_new/widgets/buttons/custom_button.dart';
import 'package:hmg_patient_app_new/widgets/common_bottom_sheet.dart';
import 'package:hmg_patient_app_new/widgets/in_app_browser/InAppBrowser.dart';
import 'package:hmg_patient_app_new/widgets/loader/bottomsheet_loader.dart';
import 'package:hmg_patient_app_new/widgets/routes/custom_page_route.dart';
import 'package:provider/provider.dart';
import 'package:smooth_corner/smooth_corner.dart';

class ImmediateLiveCarePaymentPage extends StatefulWidget {
  ImmediateLiveCarePaymentPage({super.key});

  @override
  State<ImmediateLiveCarePaymentPage> createState() => _ImmediateLiveCarePaymentPageState();
}

class _ImmediateLiveCarePaymentPageState extends State<ImmediateLiveCarePaymentPage> {
  late PayfortViewModel payfortViewModel;
  late ImmediateLiveCareViewModel immediateLiveCareViewModel;
  late MyAppointmentsViewModel myAppointmentsViewModel;
  late AppState appState;
  late PayTabsViewModel paytabsViewModel;

  MyInAppBrowser? browser;
  String selectedPaymentMethod = "";

  String transID = "";

  bool isShowTamara = false;
  String tamaraPaymentStatus = "";
  String tamaraOrderID = "";

  @override
  void initState() {
    scheduleMicrotask(() {
      payfortViewModel.initPayfortViewModel();
      myAppointmentsViewModel.getTamaraInstallmentsDetails().then((val) {
        if (myAppointmentsViewModel.getTamaraInstallmentsDetailsResponseModel != null) {
          if (num.parse(immediateLiveCareViewModel.liveCareImmediateAppointmentFeesList.total!) >= myAppointmentsViewModel.getTamaraInstallmentsDetailsResponseModel!.minLimit!.amount! &&
              num.parse(immediateLiveCareViewModel.liveCareImmediateAppointmentFeesList.total!) <= myAppointmentsViewModel.getTamaraInstallmentsDetailsResponseModel!.maxLimit!.amount!) {
            setState(() {
              isShowTamara = true;
            });
          }
        }
      });
    });
    super.initState();
  }

  @override
  Widget build(BuildContext context) {
    appState = getIt.get<AppState>();
    myAppointmentsViewModel = Provider.of<MyAppointmentsViewModel>(context, listen: false);
    immediateLiveCareViewModel = Provider.of<ImmediateLiveCareViewModel>(context, listen: false);
    payfortViewModel = Provider.of<PayfortViewModel>(context, listen: false);
    paytabsViewModel = Provider.of<PayTabsViewModel>(context, listen: false);
    return Scaffold(
      backgroundColor: AppColors.bgScaffoldColor,
      body: Consumer<MyAppointmentsViewModel>(builder: (context, myAppointmentsVM, child) {
        return Column(
          children: [
            Expanded(
              child: CollapsingListView(
                title: LocaleKeys.liveCarePayment.tr(context: context),
                child: SingleChildScrollView(
                  child: Column(
                    crossAxisAlignment: CrossAxisAlignment.start,
                    children: [
                      SizedBox(height: 24.h),
                      Container(
                        decoration: RoundedRectangleBorder().toSmoothCornerDecoration(
                          color: AppColors.whiteColor,
                          borderRadius: 20.h,
                          hasShadow: false,
                        ),
                        child: Row(
                          mainAxisSize: MainAxisSize.max,
                          children: [
                            Column(
                              crossAxisAlignment: CrossAxisAlignment.start,
                              children: [
                                Utils.buildImgWithAssets(icon: AppAssets.mada, width: 72.h, height: 25.h, fit: BoxFit.contain),
                                SizedBox(height: 16.h),
                                LocaleKeys.mada.tr(context: context).toText16(isBold: true),
                              ],
                            ),
                            SizedBox(width: 8.h),
                            const Spacer(),
                            Transform.flip(
                              flipX: appState.isArabic(),
                              child: Utils.buildSvgWithAssets(
                                icon: AppAssets.forward_arrow_icon,
                                iconColor: AppColors.blackColor,
                                width: 40.h,
                                height: 40.h,
                                fit: BoxFit.contain,
                              ),
                            ),
                          ],
                        ).paddingSymmetrical(16.h, 16.h),
                      ).paddingSymmetrical(24.h, 0.h).onPress(() async {
                        selectedPaymentMethod = "MADA";
                        if (appState.isPaytabsEnabled) {
                          transID = Utils.getAppointmentTransID(
                            immediateLiveCareViewModel.immediateLiveCareSelectedClinic.serviceID!,
                            ApiConsts.appEnvironmentType == AppEnvironmentTypeEnum.uat ? 15 : 12,
                            DateTime.now().millisecondsSinceEpoch,
                          );
                          paytabsViewModel.setPaymentConfiguration(
                            "LiveCare Payment",
                            num.parse(immediateLiveCareViewModel.liveCareImmediateAppointmentFeesList.total ?? "0.0"),
                          );
                          paytabsViewModel.startCardPayment(
                              paymentOption: selectedPaymentMethod,
                              liveServiceID: immediateLiveCareViewModel.immediateLiveCareSelectedClinic.serviceID.toString(),
                              isScheduleLiveCare: "false",
                              appointmentDate: DateUtil.convertDateToString(DateTime.now()),
                              appointmentNo: "0",
                              doctorID: "0",
                              transactionID: transID,
                              amount: myAppointmentsViewModel.patientAppointmentShareResponseModel!.patientShareWithTax!.toString(),
                              fileNumber: appState.getAuthenticatedUser()!.patientId.toString(),
                              orderDescription: "LiveCare Payment",
                              serviceID: ServiceTypeEnum.appointmentPayment.getIdFromServiceEnum().toString(),
                              projectID: (ApiConsts.appEnvironmentType == AppEnvironmentTypeEnum.uat ? 15 : 12).toString(),
                              onSuccess: (PaytabsTransactionResponseModel transactionData) async {
                            LoaderBottomSheet.showLoader(loadingText: LocaleKeys.checkingPaymentStatusPleaseWait.tr());
                            await immediateLiveCareViewModel.addNewCallRequestForImmediateLiveCare(transactionData.transactionReference!);
                            await immediateLiveCareViewModel.getPatientLiveCareHistory();
                            LoaderBottomSheet.hideLoader();
                            if (immediateLiveCareViewModel.patientHasPendingLiveCareRequest) {
                              Navigator.pushAndRemoveUntil(
                                  context,
                                  CustomPageRoute(
                                    page: LandingNavigation(),
                                  ),
                                  (r) => false);
                              Navigator.of(context).push(
                                CustomPageRoute(
                                  page: ImmediateLiveCarePendingRequestPage(),
                                ),
                              );
                            } else {
                              LoaderBottomSheet.hideLoader();
                              showCommonBottomSheetWithoutHeight(
                                context,
                                child: Utils.getErrorWidget(loadingText: "Unknown error occurred..."),
                                callBackFunc: () {},
                                isFullScreen: false,
                                isCloseButtonVisible: true,
                              );
                            }
                          }, onError: (err) {
                            showCommonBottomSheetWithoutHeight(
                              context,
                              child: Utils.getErrorWidget(loadingText: err.toString()),
                              callBackFunc: () {},
                              isFullScreen: false,
                              isCloseButtonVisible: true,
                            );
                          });
                        } else {
                          if (appState.isPayfortHostedPageEnabled) {
                            LoaderBottomSheet.showLoader(loadingText: LocaleKeys.fetchingPaymentInformation.tr(context: context));
                            transID = Utils.getAppointmentTransID(
                              immediateLiveCareViewModel.immediateLiveCareSelectedClinic.serviceID!,
                              ApiConsts.appEnvironmentType == AppEnvironmentTypeEnum.uat ? 15 : 12,
                              DateTime.now().millisecondsSinceEpoch,
                            );
                            await payfortViewModel.getPayfortConfigurations(
                                serviceId: ServiceTypeEnum.liveCareAppointment.getIdFromServiceEnum(),
                                projectId: ApiConsts.appEnvironmentType == AppEnvironmentTypeEnum.uat ? 15 : 12,
                                integrationId: 1);

                            payfortViewModel.initiatePaymentWithCard(
                              "mada",
                              immediateLiveCareViewModel.immediateLiveCareSelectedClinic.serviceID.toString(),
                              "false",
                              DateUtil.convertDateToString(DateTime.now()),
                              "0",
                              "0",
                              transactionID: transID,
                              fileNumber: appState.getAuthenticatedUser()!.patientId.toString(),
                              amount: immediateLiveCareViewModel.liveCareImmediateAppointmentFeesList.total ?? "0.0",
                              orderDescription: "LiveCare Payment",
                              onSucceeded: (paymentResult) async {
                                print("Payment Success Data: ${paymentResult.toString()}");
                                LoaderBottomSheet.showLoader(loadingText: LocaleKeys.checkingPaymentStatusPleaseWait.tr(context: context));

                                await immediateLiveCareViewModel.addNewCallRequestForImmediateLiveCare(transID);
                                await immediateLiveCareViewModel.getPatientLiveCareHistory();
                                LoaderBottomSheet.hideLoader();
                                if (immediateLiveCareViewModel.patientHasPendingLiveCareRequest) {
                                  Navigator.pushAndRemoveUntil(
                                      context,
                                      CustomPageRoute(
                                        page: LandingNavigation(),
                                      ),
                                      (r) => false);
                                  Navigator.of(context).push(
                                    CustomPageRoute(
                                      page: ImmediateLiveCarePendingRequestPage(),
                                    ),
                                  );
                                } else {
                                  LoaderBottomSheet.hideLoader();
                                  showCommonBottomSheetWithoutHeight(
                                    context,
                                    child: Utils.getErrorWidget(loadingText: "Unknown error occurred..."),
                                    callBackFunc: () {},
                                    isFullScreen: false,
                                    isCloseButtonVisible: true,
                                  );
                                }
                              },
                              onFailed: (err) {
                                print("Payment Failed Data: ${err.toString()}");
                                showCommonBottomSheetWithoutHeight(
                                  context,
                                  child: Utils.getErrorWidget(loadingText: LocaleKeys.paymentFailedPleaseTryAgain.tr(context: context)),
                                  callBackFunc: () {},
                                  isFullScreen: false,
                                  isCloseButtonVisible: true,
                                );
                              },
                            );
                          } else {
                            openPaymentURL("mada");
                          }
                        }
                      }),
                      SizedBox(height: 16.h),
                      Container(
                        decoration: RoundedRectangleBorder().toSmoothCornerDecoration(
                          color: AppColors.whiteColor,
                          borderRadius: 20.h,
                          hasShadow: false,
                        ),
                        child: Row(
                          mainAxisSize: MainAxisSize.max,
                          children: [
                            Column(
                              crossAxisAlignment: CrossAxisAlignment.start,
                              children: [
                                Row(
                                  children: [
                                    Utils.buildImgWithAssets(icon: AppAssets.visa, width: 50.h, height: 50.h),
                                    SizedBox(width: 8.h),
                                    Utils.buildImgWithAssets(icon: AppAssets.mastercard, width: 40.h, height: 40.h, fit: BoxFit.contain),
                                  ],
                                ),
                                SizedBox(height: 16.h),
                                LocaleKeys.visaOrMastercard.tr(context: context).toText16(isBold: true),
                              ],
                            ),
                            SizedBox(width: 8.h),
                            const Spacer(),
                            Transform.flip(
                              flipX: appState.isArabic(),
                              child: Utils.buildSvgWithAssets(
                                icon: AppAssets.forward_arrow_icon,
                                iconColor: AppColors.blackColor,
                                width: 40.h,
                                height: 40.h,
                                fit: BoxFit.contain,
                              ),
                            ),
                          ],
                        ).paddingSymmetrical(16.h, 16.h),
                      ).paddingSymmetrical(24.h, 0.h).onPress(() async {
                        selectedPaymentMethod = "VISA";
                        if (appState.isPaytabsEnabled) {
                          transID = Utils.getAppointmentTransID(
                            immediateLiveCareViewModel.immediateLiveCareSelectedClinic.serviceID!,
                            ApiConsts.appEnvironmentType == AppEnvironmentTypeEnum.uat ? 15 : 12,
                            DateTime.now().millisecondsSinceEpoch,
                          );
                          paytabsViewModel.setPaymentConfiguration(
                            "LiveCare Payment",
                            num.parse(immediateLiveCareViewModel.liveCareImmediateAppointmentFeesList.total ?? "0.0"),
                          );
                          paytabsViewModel.startCardPayment(
                              paymentOption: selectedPaymentMethod,
                              liveServiceID: immediateLiveCareViewModel.immediateLiveCareSelectedClinic.serviceID.toString(),
                              isScheduleLiveCare: "false",
                              appointmentDate: DateUtil.convertDateToString(DateTime.now()),
                              appointmentNo: "0",
                              doctorID: "0",
                              transactionID: transID,
                              amount: myAppointmentsViewModel.patientAppointmentShareResponseModel!.patientShareWithTax!.toString(),
                              fileNumber: appState.getAuthenticatedUser()!.patientId.toString(),
                              orderDescription: "LiveCare Payment",
                              serviceID: ServiceTypeEnum.appointmentPayment.getIdFromServiceEnum().toString(),
                              projectID: (ApiConsts.appEnvironmentType == AppEnvironmentTypeEnum.uat ? 15 : 12).toString(),
                              onSuccess: (PaytabsTransactionResponseModel transactionData) async {
                            LoaderBottomSheet.showLoader(loadingText: LocaleKeys.checkingPaymentStatusPleaseWait.tr());
                            await immediateLiveCareViewModel.addNewCallRequestForImmediateLiveCare(transactionData.transactionReference!);
                            await immediateLiveCareViewModel.getPatientLiveCareHistory();
                            LoaderBottomSheet.hideLoader();
                            if (immediateLiveCareViewModel.patientHasPendingLiveCareRequest) {
                              Navigator.pushAndRemoveUntil(
                                  context,
                                  CustomPageRoute(
                                    page: LandingNavigation(),
                                  ),
                                  (r) => false);
                              Navigator.of(context).push(
                                CustomPageRoute(
                                  page: ImmediateLiveCarePendingRequestPage(),
                                ),
                              );
                            } else {
                              LoaderBottomSheet.hideLoader();
                              showCommonBottomSheetWithoutHeight(
                                context,
                                child: Utils.getErrorWidget(loadingText: "Unknown error occurred..."),
                                callBackFunc: () {},
                                isFullScreen: false,
                                isCloseButtonVisible: true,
                              );
                            }
                          }, onError: (err) {
                            showCommonBottomSheetWithoutHeight(
                              context,
                              child: Utils.getErrorWidget(loadingText: err.toString()),
                              callBackFunc: () {},
                              isFullScreen: false,
                              isCloseButtonVisible: true,
                            );
                          });
                        } else {
                          if (appState.isPayfortHostedPageEnabled) {
                            LoaderBottomSheet.showLoader(loadingText: LocaleKeys.fetchingPaymentInformation.tr(context: context));
                            transID = Utils.getAppointmentTransID(
                              immediateLiveCareViewModel.immediateLiveCareSelectedClinic.serviceID!,
                              ApiConsts.appEnvironmentType == AppEnvironmentTypeEnum.uat ? 15 : 12,
                              DateTime.now().millisecondsSinceEpoch,
                            );
                            await payfortViewModel.getPayfortConfigurations(
                                serviceId: ServiceTypeEnum.liveCareAppointment.getIdFromServiceEnum(),
                                projectId: ApiConsts.appEnvironmentType == AppEnvironmentTypeEnum.uat ? 15 : 12,
                                integrationId: 1);

                            payfortViewModel.initiatePaymentWithCard(
                              "visa",
                              immediateLiveCareViewModel.immediateLiveCareSelectedClinic.serviceID.toString(),
                              "false",
                              DateUtil.convertDateToString(DateTime.now()),
                              "0",
                              "0",
                              transactionID: transID,
                              fileNumber: appState.getAuthenticatedUser()!.patientId.toString(),
                              amount: immediateLiveCareViewModel.liveCareImmediateAppointmentFeesList.total ?? "0.0",
                              orderDescription: "LiveCare Payment",
                              onSucceeded: (paymentResult) async {
                                print("Payment Success Data: ${paymentResult.toString()}");
                                LoaderBottomSheet.showLoader(loadingText: LocaleKeys.checkingPaymentStatusPleaseWait.tr(context: context));

                                await immediateLiveCareViewModel.addNewCallRequestForImmediateLiveCare(transID);
                                await immediateLiveCareViewModel.getPatientLiveCareHistory();
                                LoaderBottomSheet.hideLoader();
                                if (immediateLiveCareViewModel.patientHasPendingLiveCareRequest) {
                                  Navigator.pushAndRemoveUntil(
                                      context,
                                      CustomPageRoute(
                                        page: LandingNavigation(),
                                      ),
                                      (r) => false);
                                  Navigator.of(context).push(
                                    CustomPageRoute(
                                      page: ImmediateLiveCarePendingRequestPage(),
                                    ),
                                  );
                                } else {
                                  LoaderBottomSheet.hideLoader();
                                  showCommonBottomSheetWithoutHeight(
                                    context,
                                    child: Utils.getErrorWidget(loadingText: "Unknown error occurred..."),
                                    callBackFunc: () {},
                                    isFullScreen: false,
                                    isCloseButtonVisible: true,
                                  );
                                }
                              },
                              onFailed: (err) {
                                print("Payment Failed Data: ${err.toString()}");
                                showCommonBottomSheetWithoutHeight(
                                  context,
                                  child: Utils.getErrorWidget(loadingText: LocaleKeys.paymentFailedPleaseTryAgain.tr(context: context)),
                                  callBackFunc: () {},
                                  isFullScreen: false,
                                  isCloseButtonVisible: true,
                                );
                              },
                            );
                          } else {
                            openPaymentURL("visa");
                          }
                        }
                      }),
                      SizedBox(height: 16.h),
                      isShowTamara
                          ? Container(
                              decoration: RoundedRectangleBorder().toSmoothCornerDecoration(
                                color: AppColors.whiteColor,
                          borderRadius: 20.h,
                          hasShadow: false,
                        ),
                        child: Row(
                          mainAxisSize: MainAxisSize.max,
                          children: [
                            Column(
                              crossAxisAlignment: CrossAxisAlignment.start,
                              children: [
                                Utils.buildImgWithAssets(icon: AppAssets.tamaraEng, width: 72.h, height: 25.h),
                                SizedBox(height: 16.h),
                                LocaleKeys.tamara.tr(context: context).toText16(isBold: true),
                              ],
                            ),
                            SizedBox(width: 8.h),
                            const Spacer(),
                            Transform.flip(
                              flipX: appState.isArabic(),
                              child: Utils.buildSvgWithAssets(
                                icon: AppAssets.forward_arrow_icon,
                                iconColor: AppColors.blackColor,
                                width: 40.h,
                                height: 40.h,
                                fit: BoxFit.contain,
                              ),
                            ),
                          ],
                        ).paddingSymmetrical(16.h, 16.h),
                      ).paddingSymmetrical(24.h, 0.h).onPress(() {
                        selectedPaymentMethod = "TAMARA";
                        openPaymentURL("tamara");
                            })
                          : SizedBox.shrink(),
                    ],
                  ),
                ),
              ),
            ),
            Container(
              decoration: RoundedRectangleBorder().toSmoothCornerDecoration(
                color: AppColors.whiteColor,
                borderRadius: 24.h,
                hasShadow: false,
              ),
              child: Consumer<PayfortViewModel>(builder: (context, payfortVM, child) {
                //TODO: Need to add loading state & animation for Apple Pay Configuration
                return Column(
                  crossAxisAlignment: CrossAxisAlignment.start,
                  children: [
                    (immediateLiveCareViewModel.liveCareImmediateAppointmentFeesList.isCash ?? true)
                        ? Container(
                            height: 50.h,
                            decoration: ShapeDecoration(
                              color: AppColors.secondaryLightRedBorderColor,
                              shape: SmoothRectangleBorder(
                                borderRadius: BorderRadius.only(topLeft: Radius.circular(24), topRight: Radius.circular(24)),
                                smoothness: 1,
                              ),
                            ),
                            child: Row(
                              mainAxisAlignment: MainAxisAlignment.spaceBetween,
                              children: [
                                LocaleKeys.insuranceExpiredOrInactive.tr().toText14(color: AppColors.primaryRedColor, isBold: true).paddingSymmetrical(24.h, 0.h),
                                CustomButton(
                                  text: LocaleKeys.updateInsurance.tr(context: context),
                                  onPressed: () {
                                    Navigator.of(context).push(
                                      CustomPageRoute(
                                        page: InsuranceHomePage(),
                                      ),
                                    );
                                  },
                                  backgroundColor: AppColors.primaryRedColor,
                                  borderColor: AppColors.secondaryLightRedBorderColor,
                                  textColor: AppColors.whiteColor,
                                  fontSize: 10,
                                  fontWeight: FontWeight.w600,
                                  borderRadius: 8,
                                  padding: EdgeInsets.fromLTRB(15, 0, 15, 0),
                                  height: 30.h,
                                ).paddingSymmetrical(24.h, 0.h),
                              ],
                            ),
                          )
                        : const SizedBox(),
                    SizedBox(height: 24.h),
                    LocaleKeys.totalAmountToPay.tr().toText18(isBold: true).paddingSymmetrical(24.h, 0.h),
                    SizedBox(height: 17.h),
                    Row(
                      mainAxisAlignment: MainAxisAlignment.spaceBetween,
                      children: [
                        LocaleKeys.amountBeforeTax.tr().toText14(isBold: true),
                        Utils.getPaymentAmountWithSymbol((immediateLiveCareViewModel.liveCareImmediateAppointmentFeesList.amount ?? "0.0").toString().toText16(isBold: true), AppColors.blackColor, 13,
                            isSaudiCurrency: true),
                      ],
                    ).paddingSymmetrical(24.h, 0.h),
                    Row(
                      mainAxisAlignment: MainAxisAlignment.spaceBetween,
                      children: [
                        LocaleKeys.vat15.tr().toText14(isBold: true, color: AppColors.greyTextColor),
                        Utils.getPaymentAmountWithSymbol(
                            (immediateLiveCareViewModel.liveCareImmediateAppointmentFeesList.tax ?? "0.0").toString().toText14(isBold: true, color: AppColors.greyTextColor), AppColors.greyTextColor, 13,
                            isSaudiCurrency: true),
                      ],
                    ).paddingSymmetrical(24.h, 0.h),
                    SizedBox(height: 17.h),
                    Row(
                      mainAxisAlignment: MainAxisAlignment.spaceBetween,
                      children: [
                        "".toText14(isBold: true),
                        Utils.getPaymentAmountWithSymbol((immediateLiveCareViewModel.liveCareImmediateAppointmentFeesList.total ?? "0.0").toString().toText24(isBold: true), AppColors.blackColor, 17,
                            isSaudiCurrency: true),
                      ],
                    ).paddingSymmetrical(24.h, 0.h),
                    Platform.isIOS
                        ? Utils.buildSvgWithAssets(
                            icon: AppAssets.apple_pay_button,
                            width: 200.h,
                            height: 80.h,
                            fit: BoxFit.contain,
                      applyThemeColor: false
                          ).paddingSymmetrical(24.h, 0.h).onPress(() {
                            // payfortVM.setIsApplePayConfigurationLoading(true);
                            if (Utils.havePrivilege(103)) {
                              startApplePay();
                            } else {
                              openPaymentURL("ApplePay");
                            }
                          })
                        : SizedBox(height: 12.h),
                    SizedBox(height: 12.h),
                  ],
                );
              }),
            ),
          ],
        );
      }),
    );
  }

  onBrowserLoadStart(String url) {
    print("onBrowserLoadStart");
    print(url);

    if (selectedPaymentMethod == "TAMARA") {
      if (Platform.isAndroid) {
        Uri uri = new Uri.dataFromString(url);
        tamaraPaymentStatus = uri.queryParameters['status'] ?? "";
        tamaraOrderID = uri.queryParameters['AuthorizePaymentId'] ?? "";
      } else {
        Uri uri = new Uri.dataFromString(url);
        tamaraPaymentStatus = uri.queryParameters['paymentStatus'] ?? "";
        tamaraOrderID = uri.queryParameters['orderId'] ?? "";
      }
    }

    // if(selectedPaymentMethod != "TAMARA") {
    MyInAppBrowser.successURLS.forEach((element) {
      if (url.contains(element)) {
        browser?.close();
        MyInAppBrowser.isPaymentDone = true;
        return;
      }
    });
    // }

    // if(selectedPaymentMethod != "TAMARA") {
    MyInAppBrowser.errorURLS.forEach((element) {
      if (url.contains(element)) {
        browser?.close();
        MyInAppBrowser.isPaymentDone = false;
        return;
      }
    });
    // }
  }

  onBrowserExit(bool isPaymentMade) async {
    debugPrint("onBrowserExit Called!!!!");
    checkPaymentStatus();
  }

  void checkPaymentStatus() async {
    LoaderBottomSheet.showLoader(loadingText: LocaleKeys.checkingPaymentStatusPleaseWait.tr());
    if (selectedPaymentMethod == "TAMARA") {
      await payfortViewModel.checkTamaraPaymentStatus(
          transactionID: transID,
          onSuccess: (apiResponse) async {
            if (apiResponse.data["status"].toString().toLowerCase() == "success") {
              tamaraOrderID = apiResponse.data["tamara_order_id"].toString();
              await payfortViewModel.updateTamaraRequestStatus(responseMessage: "success", status: "14", clientRequestID: transID, tamaraOrderID: tamaraOrderID);
              await immediateLiveCareViewModel.addNewCallRequestForImmediateLiveCare(transID);
              await immediateLiveCareViewModel.getPatientLiveCareHistory();
              LoaderBottomSheet.hideLoader();
              if (immediateLiveCareViewModel.patientHasPendingLiveCareRequest) {
                Navigator.pushAndRemoveUntil(
                    context,
                    CustomPageRoute(
                      page: LandingNavigation(),
                    ),
                    (r) => false);
                Navigator.of(context).push(
                  CustomPageRoute(
                    page: ImmediateLiveCarePendingRequestPage(),
                  ),
                );
              } else {
                showCommonBottomSheetWithoutHeight(
                  context,
                  child: Utils.getErrorWidget(loadingText: "Unknown error occurred..."),
                  callBackFunc: () {},
                  isFullScreen: false,
                  isCloseButtonVisible: true,
                );
              }
            } else {
              await payfortViewModel.updateTamaraRequestStatus(responseMessage: "Failed", status: "00", clientRequestID: transID, tamaraOrderID: tamaraOrderID);
              LoaderBottomSheet.hideLoader();
              showCommonBottomSheetWithoutHeight(
                context,
                child: Utils.getErrorWidget(loadingText: LocaleKeys.paymentFailedPleaseTryAgain.tr()),
                callBackFunc: () {},
                isFullScreen: false,
                isCloseButtonVisible: true,
              );
            }
          },
          onError: (err) {
            LoaderBottomSheet.hideLoader();
            showCommonBottomSheetWithoutHeight(
              context,
              child: Utils.getErrorWidget(loadingText: err),
              callBackFunc: () {},
              isFullScreen: false,
              isCloseButtonVisible: true,
            );
          });
    } else {
      await payfortViewModel.checkPaymentStatus(
          transactionID: transID,
          onSuccess: (apiResponse) async {
            debugPrint(apiResponse.data.toString());
            if (payfortViewModel.payfortCheckPaymentStatusResponseModel!.responseMessage!.toLowerCase() == "success") {
              await immediateLiveCareViewModel.addNewCallRequestForImmediateLiveCare(transID);
              await immediateLiveCareViewModel.getPatientLiveCareHistory();
              LoaderBottomSheet.hideLoader();
              if (immediateLiveCareViewModel.patientHasPendingLiveCareRequest) {
                Navigator.pushAndRemoveUntil(
                    context,
                    CustomPageRoute(
                      page: LandingNavigation(),
                    ),
                    (r) => false);
                Navigator.of(context).push(
                  CustomPageRoute(
                    page: ImmediateLiveCarePendingRequestPage(),
                  ),
                );
              } else {
                LoaderBottomSheet.hideLoader();
                showCommonBottomSheetWithoutHeight(
                  context,
                  child: Utils.getErrorWidget(loadingText: "Unknown error occurred..."),
                  callBackFunc: () {},
                  isFullScreen: false,
                  isCloseButtonVisible: true,
                );
              }
            } else {
              LoaderBottomSheet.hideLoader();
              showCommonBottomSheetWithoutHeight(
                context,
                child: Utils.getErrorWidget(loadingText: LocaleKeys.paymentFailedPleaseTryAgain.tr()),
                callBackFunc: () {},
                isFullScreen: false,
                isCloseButtonVisible: true,
              );
            }
          });
    }
  }

  openPaymentURL(String paymentMethod) {
    browser = MyInAppBrowser(onExitCallback: onBrowserExit, onLoadStartCallback: onBrowserLoadStart, context: context);
    transID = Utils.getAppointmentTransID(
      immediateLiveCareViewModel.immediateLiveCareSelectedClinic.serviceID!,
      ApiConsts.appEnvironmentType == AppEnvironmentTypeEnum.uat ? 15 : 12,
      DateTime.now().millisecondsSinceEpoch,
    );

    //TODO: Need to pass dynamic params to the payment request instead of static values
    browser?.openPaymentBrowser(
        num.parse(immediateLiveCareViewModel.liveCareImmediateAppointmentFeesList.total ?? "0.0"),
        "LiveCare Payment",
        transID,
        "12",
        "CustID_${appState.getAuthenticatedUser()!.patientId.toString()}@HMG.com",
        selectedPaymentMethod,
        appState.getAuthenticatedUser()!.patientType.toString(),
        "${appState.getAuthenticatedUser()!.firstName} ${appState.getAuthenticatedUser()!.lastName}",
        appState.getAuthenticatedUser()!.patientId.toString(),
        appState.getAuthenticatedUser()!,
        browser!,
        false,
        "4",
        immediateLiveCareViewModel.immediateLiveCareSelectedClinic.serviceID.toString(),
        context,
        "3");
  }

  startApplePay() async {
    LoaderBottomSheet.showLoader(loadingText: LocaleKeys.fetchingApplePayDetails.tr());
    transID = Utils.getAppointmentTransID(
      immediateLiveCareViewModel.immediateLiveCareSelectedClinic.serviceID!,
      ApiConsts.appEnvironmentType == AppEnvironmentTypeEnum.uat ? 15 : 12,
      DateTime.now().millisecondsSinceEpoch,
    );

    ApplePayInsertRequest applePayInsertRequest = ApplePayInsertRequest();

    await payfortViewModel.getPayfortConfigurations(
        serviceId: ServiceTypeEnum.liveCareAppointment.getIdFromServiceEnum(), projectId: ApiConsts.appEnvironmentType == AppEnvironmentTypeEnum.uat ? 15 : 12, integrationId: 2);

    applePayInsertRequest.clientRequestID = transID;
    applePayInsertRequest.clinicID = immediateLiveCareViewModel.immediateLiveCareSelectedClinic.serviceID!;

    // TODO: Need to pass dynamic currency coming from the API
    applePayInsertRequest.currency = appState.getAuthenticatedUser()!.outSa! == 0 ? "SAR" : "AED";
    applePayInsertRequest.customerEmail = "CustID_${appState.getAuthenticatedUser()!.patientId.toString()}@HMG.com";
    applePayInsertRequest.customerID = appState.getAuthenticatedUser()!.patientId.toString();
    applePayInsertRequest.customerName = "${appState.getAuthenticatedUser()!.firstName} ${appState.getAuthenticatedUser()!.lastName}";

    applePayInsertRequest.deviceToken = await Utils.getStringFromPrefs(CacheConst.pushToken);
    applePayInsertRequest.voipToken = await Utils.getStringFromPrefs(CacheConst.voipToken);
    applePayInsertRequest.doctorID = 0;
    applePayInsertRequest.projectID = "12";
    applePayInsertRequest.serviceID = ServiceTypeEnum.liveCareAppointment.getIdFromServiceEnum().toString();
    applePayInsertRequest.channelID = 3;
    applePayInsertRequest.patientID = appState.getAuthenticatedUser()!.patientId.toString();
    applePayInsertRequest.patientTypeID = appState.getAuthenticatedUser()!.patientType;
    applePayInsertRequest.patientOutSA = appState.getAuthenticatedUser()!.outSa;
    applePayInsertRequest.appointmentDate = DateUtil.convertDateToString(DateTime.now());
    applePayInsertRequest.appointmentNo = 0;
    applePayInsertRequest.orderDescription = "LiveCare Payment";
    applePayInsertRequest.liveServiceID = immediateLiveCareViewModel.immediateLiveCareSelectedClinic.serviceID!.toString();
    applePayInsertRequest.latitude = "0.0";
    applePayInsertRequest.longitude = "0.0";
    applePayInsertRequest.amount = immediateLiveCareViewModel.liveCareImmediateAppointmentFeesList.total.toString();
    applePayInsertRequest.isSchedule = "0";
    applePayInsertRequest.language = appState.isArabic() ? 'ar' : 'en';
    applePayInsertRequest.languageID = appState.isArabic() ? 1 : 2;
    applePayInsertRequest.userName = appState.getAuthenticatedUser()!.patientId;
    applePayInsertRequest.responseContinueURL = "http://hmg.com/Documents/success.html";
    applePayInsertRequest.backClickUrl = "http://hmg.com/Documents/success.html";
    applePayInsertRequest.paymentOption = "ApplePay";

    applePayInsertRequest.isMobSDK = true;
    applePayInsertRequest.merchantReference = transID;
    applePayInsertRequest.merchantIdentifier = payfortViewModel.payfortProjectDetailsRespModel!.merchantIdentifier;
    applePayInsertRequest.commandType = "PURCHASE";
    applePayInsertRequest.signature = payfortViewModel.payfortProjectDetailsRespModel!.signature;
    applePayInsertRequest.accessCode = payfortViewModel.payfortProjectDetailsRespModel!.accessCode;
    applePayInsertRequest.shaRequestPhrase = payfortViewModel.payfortProjectDetailsRespModel!.shaRequest;
    applePayInsertRequest.shaResponsePhrase = payfortViewModel.payfortProjectDetailsRespModel!.shaResponse;
    applePayInsertRequest.returnURL = "";

    //TODO: Need to pass dynamic params to the Apple Pay instead of static values
    await payfortViewModel.applePayRequestInsert(applePayInsertRequest: applePayInsertRequest).then((value) {
      if (appState.isPaytabsEnabled) {
        selectedPaymentMethod = "VISA";
        LoaderBottomSheet.hideLoader();
        paytabsViewModel.setPaymentConfiguration("Advance Payment", num.parse((immediateLiveCareViewModel.liveCareImmediateAppointmentFeesList.total ?? "0.0")));
        paytabsViewModel.startApplePayPayment(onSuccess: (PaytabsTransactionResponseModel transactionData) async {
          LoaderBottomSheet.showLoader(loadingText: LocaleKeys.checkingPaymentStatusPleaseWait.tr());
          await immediateLiveCareViewModel.addNewCallRequestForImmediateLiveCare(transactionData.transactionReference!);
          await immediateLiveCareViewModel.getPatientLiveCareHistory();
          LoaderBottomSheet.hideLoader();
          if (immediateLiveCareViewModel.patientHasPendingLiveCareRequest) {
            Navigator.pushAndRemoveUntil(
                context,
                CustomPageRoute(
                  page: LandingNavigation(),
                ),
                (r) => false);
            Navigator.of(context).push(
              CustomPageRoute(
                page: ImmediateLiveCarePendingRequestPage(),
              ),
            );
          } else {
            LoaderBottomSheet.hideLoader();
            showCommonBottomSheetWithoutHeight(
              context,
              child: Utils.getErrorWidget(loadingText: "Unknown error occurred..."),
              callBackFunc: () {},
              isFullScreen: false,
              isCloseButtonVisible: true,
            );
          }
        }, onError: (err) {
          showCommonBottomSheetWithoutHeight(
            context,
            child: Utils.getErrorWidget(loadingText: err.toString()),
            callBackFunc: () {},
            isFullScreen: false,
            isCloseButtonVisible: true,
          );
        });
      } else {
        payfortViewModel.paymentWithApplePay(
          customerName: "${appState.getAuthenticatedUser()!.firstName} ${appState.getAuthenticatedUser()!.lastName}",
          // customerEmail: projectViewModel.authenticatedUserObject.user.emailAddress,
          customerEmail: "CustID_${appState.getAuthenticatedUser()!.patientId.toString()}@HMG.com",
          orderDescription: "LiveCare Payment",
          orderAmount: num.parse((immediateLiveCareViewModel.liveCareImmediateAppointmentFeesList.total ?? "0.0")),
          merchantReference: transID,
          merchantIdentifier: payfortViewModel.payfortProjectDetailsRespModel!.merchantIdentifier,
          applePayAccessCode: payfortViewModel.payfortProjectDetailsRespModel!.accessCode,
          applePayShaRequestPhrase: payfortViewModel.payfortProjectDetailsRespModel!.shaRequest,
          currency: appState.getAuthenticatedUser()!.outSa! == 0 ? "SAR" : "AED",
          onFailed: (failureResult) async {
            log("failureResult: ${failureResult.message.toString()}");
            LoaderBottomSheet.hideLoader();
            showCommonBottomSheetWithoutHeight(
              context,
              child: Utils.getErrorWidget(loadingText: failureResult.message.toString()),
              callBackFunc: () {},
              isFullScreen: false,
              isCloseButtonVisible: true,
            );
          },
          onSucceeded: (successResult) async {
            LoaderBottomSheet.hideLoader();
            log("successResult: ${successResult.responseMessage.toString()}");
            selectedPaymentMethod = successResult.paymentOption ?? "VISA";
            checkPaymentStatus();
          },
          // projectId: appo.projectID,
          // serviceTypeEnum: ServiceTypeEnum.appointmentPayment,
        );
      }
    });
  }
}
